
// SOURCE CODE HEADER
//
// myservice.h
// Purpose: Run an application as a NT/95/98 service
// Contact: jeffg@cips.ca
// Legalese: This source code is public domain
// Based on MSDN example code by Nigel Thomson (nigelt@microsoft.com)
// Modified to also run as Win95/98 service by Steve Porter (steve@dcypher.net)
// Modified for the ECDL2K-108 challenge by Jeff Gilchrist (jeffg@cips.ca).

#include "ntservice.h"

class CMyService : public CNTService
{
public:
	CMyService(void);
	virtual BOOL OnInit(void);
    virtual void Run(void);
    virtual BOOL OnUserControl(DWORD dwOpcode);
    virtual void OnShutdown(void);
    void SaveStatus(void);

	int m_iStartParam;	// Control parameters
	int m_iIncParam;
	int m_iState;		// Current state
};
