
class OsInfo
{
public:
	enum OsDesc	{ UnSet = 0, Win31 = 1, Win95 = 2, Win98 = 3, WinNT = 4, Unknown = 5 };
private:
	static OsDesc  OsD;
	static const char *v_str[6];
	static void get_info(void);
public:
	inline OsInfo(void) { if(OsD == UnSet) get_info(); };
	inline const OsDesc id(void)   { return OsD; };
	inline const char*  name(void) { return v_str[(int)OsD]; };
};

// read the Pentium Time Stamp Counter

inline void cycles(unsigned long *rtn)
{    __asm   
	{
	_emit   0x0f
    _emit   0x31
	shrd	eax,edx,8
	mov		ebx,rtn
    mov     [ebx],eax
	}
}

// detect presence of MMX instructions

inline bool has_mmx(void)
{	unsigned long mmx_flag;

	__asm
	{	mov		eax,1
		cpuid
		and		edx,0x00800000
		mov		mmx_flag,edx
	}

	return mmx_flag != 0;
}

double get_time(void);
